
/**
 * /!\ This file is automatically generated by QLALR from CooLexerIO.g.
 * /!\ Don't edit it!
 */

#ifndef COOLEXERIO_HPP
#define COOLEXERIO_HPP

#include <ShareablePoints/ShareablePointsList.hpp>
#include <editors/text/LexerParser.hpp>

#include "PluginsGlobal.hpp"
#include "table_coolexerio_p.h"

class SUGL_SHARED_EXPORT CooLexerIO : public LexerParser<Table_CooLexerIO>
{
	Q_OBJECT

public:
	CooLexerIO(QObject *parent = nullptr);
	virtual ~CooLexerIO() override = default;

	// QsciLexerCustom
	enum Styles
	{
		/** Default */
		Default,
		/** Comment / ignored part */
		Comment,
		/** not special stuff */
		Normal,
		/** Coordinate system */
		Referential,
		/** Name of a point */
		PointName,
		/** Coordinates of a point */
		PointCoordinate,
		/** Sigmas of a point */
		PointSigma,
		PointSigmaKeyword,
		/** Displacements of a point */
		PointDisplacement,
		/** Informations */
		PointInfo,
		/** Type of point (VXY...) */
		PointType,
		/** Frames */
		Frame,
		FrameID,
		FrameTranslation,
		FrameRotation
	};
	// implemented in CooLexerIO_impl.cpp
	virtual const char *language() const override { return "CooPoint"; }
	virtual const char *keywords(int set) const override;
	virtual QString description(int style) const override;
	virtual const char *wordCharacters() const override;
	virtual bool defaultEolFill(int style) const override;
	QColor defaultColor(int style) const override;
	QFont defaultFont(int style) const override;
	QColor defaultPaper(int style) const override;

	// IShareablePointsListIO
	// implemented in CooLexerIO_impl.cpp
	virtual const std::string &getMIMEType() const override;
	virtual ShareablePointsList read(const std::string &contents) override;
	virtual ShareableExtraInfos readExtraInfos(const std::string &contents) override;
	virtual ShareableFrame readFrame(const std::string &contents) override;
	virtual ShareableParams readParams(const std::string &contents) override;
	virtual ShareablePoint readPoint(const std::string &contents) override;
	virtual ShareablePosition readPosition(const std::string &contents) override;
	virtual std::string write(const ShareablePointsList &list) override;
	virtual std::string write(const ShareableExtraInfos &) override { return std::string(); }
	virtual std::string write(const ShareableFrame &frame) override;
	virtual std::string write(const ShareableParams &) override { return std::string(); }
	virtual std::string write(const ShareablePoint &point) override;
	virtual std::string write(const ShareablePosition &position) override;
	
	// CooLexerIO
	/**
	 * The column line read by the lexer.
	 *
	 * This is used when the class is not used as a lexer, but as a serializer.
	 * In case you provide only one point, we can't know what are the columns. This header allows the
	 * serializer to know what is what.
	 */
	const QString &columnsHeader() const noexcept { return _columnsHeader; }
	void columnsHeader(QString header) noexcept { _columnsHeader = std::move(header); }

protected:
	// CooLexerIO
	/** Called each time we meet a point name */
	virtual void gotPointName([[maybe_unused]] QStringRef sym) {}
	/** Called each time we meet a point coordinate */
	virtual void gotPointCoordinate([[maybe_unused]] QStringRef sym) {}
	/** Called each time we meet a point sigma */
	virtual void gotPointSigma([[maybe_unused]] QStringRef sym) {}
	/** Called each time we meet a point displacement */
	virtual void gotPointDisplacement([[maybe_unused]] QStringRef sym) {}
	/** Called each time we meet a point info (ID, DDCUM...) */
	virtual void gotPointInfo([[maybe_unused]] QStringRef sym) {}
	/** Called each time we meet other (OPTION, ...) */
	virtual void gotPointType([[maybe_unused]] QStringRef sym) {}
	/** Called each time we meet a frame name */
	virtual void gotFrameName([[maybe_unused]] QStringRef sym) {}

private:
	static constexpr int COLUMNDEF = 1;
	static constexpr int OUT1MODE = 2;
	static constexpr int HTOLMODE = 3;

private:
	// LexerParser
	// generated in in LGCInputLexerIO_gen.cpp
	int nextToken(QStringRef value) override;
	void consumeRule(int ruleno) override;

private:
	QString _columnsHeader;
	ShareablePointsList _curList;
	ShareableFrame *_curFrame = nullptr;
	ShareablePoint *_curPoint = nullptr;
};

#endif // COOLEXERIO_HPP
